/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CloneResponseNewInteractions type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CloneResponseNewInteractions{}

// CloneResponseNewInteractions struct for CloneResponseNewInteractions
type CloneResponseNewInteractions struct {
	// Interaction id
	Id *string `json:"id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	OrganisationId *string `json:"organisation_id,omitempty"`
}

// NewCloneResponseNewInteractions instantiates a new CloneResponseNewInteractions object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCloneResponseNewInteractions() *CloneResponseNewInteractions {
	this := CloneResponseNewInteractions{}
	return &this
}

// NewCloneResponseNewInteractionsWithDefaults instantiates a new CloneResponseNewInteractions object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCloneResponseNewInteractionsWithDefaults() *CloneResponseNewInteractions {
	this := CloneResponseNewInteractions{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *CloneResponseNewInteractions) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneResponseNewInteractions) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *CloneResponseNewInteractions) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *CloneResponseNewInteractions) SetId(v string) {
	o.Id = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *CloneResponseNewInteractions) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneResponseNewInteractions) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *CloneResponseNewInteractions) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *CloneResponseNewInteractions) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetOrganisationId returns the OrganisationId field value if set, zero value otherwise.
func (o *CloneResponseNewInteractions) GetOrganisationId() string {
	if o == nil || IsNil(o.OrganisationId) {
		var ret string
		return ret
	}
	return *o.OrganisationId
}

// GetOrganisationIdOk returns a tuple with the OrganisationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneResponseNewInteractions) GetOrganisationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganisationId) {
		return nil, false
	}
	return o.OrganisationId, true
}

// HasOrganisationId returns a boolean if a field has been set.
func (o *CloneResponseNewInteractions) HasOrganisationId() bool {
	if o != nil && !IsNil(o.OrganisationId) {
		return true
	}

	return false
}

// SetOrganisationId gets a reference to the given string and assigns it to the OrganisationId field.
func (o *CloneResponseNewInteractions) SetOrganisationId(v string) {
	o.OrganisationId = &v
}

func (o CloneResponseNewInteractions) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CloneResponseNewInteractions) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.OrganisationId) {
		toSerialize["organisation_id"] = o.OrganisationId
	}
	return toSerialize, nil
}

type NullableCloneResponseNewInteractions struct {
	value *CloneResponseNewInteractions
	isSet bool
}

func (v NullableCloneResponseNewInteractions) Get() *CloneResponseNewInteractions {
	return v.value
}

func (v *NullableCloneResponseNewInteractions) Set(val *CloneResponseNewInteractions) {
	v.value = val
	v.isSet = true
}

func (v NullableCloneResponseNewInteractions) IsSet() bool {
	return v.isSet
}

func (v *NullableCloneResponseNewInteractions) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCloneResponseNewInteractions(val *CloneResponseNewInteractions) *NullableCloneResponseNewInteractions {
	return &NullableCloneResponseNewInteractions{value: val, isSet: true}
}

func (v NullableCloneResponseNewInteractions) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCloneResponseNewInteractions) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


